      program ana_hist ! Bernd Berg Jul 7 2002.
C Prepares energy histogram plots and calculates average energy (action).
      include '../../Libs/Fortran/implicit.sta'
      include '../../Libs/Fortran/constants.par'
      character cd*1,cq*2,cl*3
      include 'lat.par'
      include 'mc.par'
      include 'potts.par'
      include '../../Libs/Fortran_par/common_lat.f'
      include '../../Libs/Fortran_par/common_potts.f'
      include 'lat.dat'
      dimension ham(0:mlink),hae(0:mlink),actl(nrpt)
C
      write(cd,'(I1.1)') nd ! Prepare to read the data.
      write(cq,'(I2.2)') nq
      write(cl,'(I3.3)') nla(1)
      open(iud1,file="p"//cd//"d"//cq//"q"//cl//".D",
     &     form="unformatted",status="old")
c     open(iud1,file="p"//cd//"d"//cq//"q"//cl//"hb.D",
c    &     form="unformatted",status="old")
      read(iud1) beta_in,nd_in,nq_in,nla,nlink
      write(iuo,'(/," beta,nlink,nd,nq,nla:",1F16.12,I9,2I3,4I5)') 
     & beta,nlink,nd_in,nq_in,nla
      write(iuo,'(" istart,nequi,nrpt,nmeas:",I9,I10,I6,I10)') 
     & istart,nequi,nrpt,nmeas
      call read_steb0(nrpt,iud1,izero,nlink,ha,ham,hae,actl)
      close(iud1)
C
      open(iud1,file="h"//cd//"d"//cq//"q"//cl//".d",
     & form="formatted",status="unknown")
      do ilink=0,nlink
        if(ham(ilink).gt.(half/nrpt)) then
          actlm=ilink/(nlink*one)
          em=nd*two*((one/nq)-actlm) ! Internal energy per site.
          write(iud1,'(I9,4G15.6)') ilink,actlm,em,ham(ilink),hae(ilink)
        end if
      end do
      close(iud1)
C
      call steb0(nrpt,actl,actlm,av,actlme)
      write(iuo,'(" actlm =",F16.9,"  +/-",F16.9)') actlm,actlme
      em=nd*two*((one/nq)-actlm) ! Internal energy per site.
      ee=nd*two*actlme
      write(iuo,'(" em    =",F16.9,"  +/-",F16.9,/)') em,ee
c
      actlm=0.64604*one ! For some checks on the literature:
      actlme=0.00006*one
      em=nd*two*((one/nq)-actlm) 
      ee=nd*two*actlme
      if(nd.eq.2.and.nq.eq.4.and.nla(1).eq.120) write(iuo,
     &  '(" beta=0.53361",a,/," em   =",F16.9,"  +/-",F16.9,/)')
     &  ' energy from Caselle et. al. NPB 562 (1999) 549:',em,ee
c
      if(nd.eq.3.and.nq.eq.2.and.nla(1).eq.14) 
     &  write(iuo,'(a,/," em_A =",F16.9,"  +/-",F16.9,/)')
     &  ' Result in Alves et. al. PRB 41 (1990) 383 notation:',
     &  (em/four),(ee/four)
c
      stop
      end

      include '../../Libs/Fortran/potts_actl.f'
      include '../../Libs/Fortran/razero.f'
      include '../../Libs/Fortran/steb0.f'
      include '../../Libs/Fortran/read_steb0.f'
