      program potts_rwj ! Bernd Berg Oct 14 2006. Compile: ../make77.
C Potts models: Energy histogram from re-weighting of naive sampling.
C               Error calculation from bins as stored.
C Select plot or single beta by activating the appropriate parameters.
      include '../../Libs/Fortran/implicit.sta'
      include '../../Libs/Fortran/constants.par'
      character cd*1,cq*2,cl*3
      include 'lat.par'
      include 'potts.par'
      include 'mc.par'
      parameter(nbeta=20,bmin=beta-half/ten,bmax=beta+half/ten)
      parameter(dbeta=(bmax-bmin)/nbeta)
c     parameter(nbeta=0,bmin=four/ten,bmax=bmin,dbeta=zero)
      include '../../Libs/Fortran_par/common_lat.f'
      include '../../Libs/Fortran_par/common_potts.f'
      dimension hasum(0:mlink),haj(0:mlink),hae(0:mlink),hbj(0:mlink),
     &  hbe(0:mlink), actlj(0:nrpt),act2lj(0:nrpt), Cj(0:nrpt)
      data hasum/(mlink+1)*zero/,hae/(mlink+1)*zero/,hbe/(mlink+1)*zero/
      include 'lat.dat'
      ltest=.true.
      ltest=.false.
      if(ltest) stop "potts_rwj: ltest."
      write(iuo,'(/," potts_rwj: jackknife reweighting",/)')
C
      write(cd,'(I1.1)') nd ! Prepare to read the data.
      write(cq,'(I2.2)') nq
      write(cl,'(I3.3)') nla(1)
      open(iud1,file="p"//cd//"d"//cq//"q"//cl//".D",
     &     form="unformatted",status="old")
      read(iud1) beta_in,nd_in,nq_in,nla,nlink,nequi_in,nrpt_in,nmeas_in
      if(nrpt.ne.nrpt_in) stop "nrpt.ne.nrpt_in."
      if(nmeas.ne.nmeas_in) stop "nmeas.ne.nmeas_in."
      do irpt=1,nrpt
        read(iud1) ha,acpt,irpt_in
        do ilink=0,mlink
          hasum(ilink)=hasum(ilink)+ha(ilink)
        enddo
      enddo
C
      open(iud2,file="p"//cl//"rwj.d",form='formatted',status='unknown')
      do ibeta=0,nbeta
        beta0=bmin+ibeta*dbeta
        Cfactor=ms*(beta0*2*nd)**2
        write(iuo,'(" ibeta,beta0 =",I6,F12.6)') ibeta,beta0
        call potts_rwght(mlink,hasum,hae,beta,beta0,hbj,hbe)
        actlj(0)=potts_actl(mlink,hbj)
        act2lj(0)=potts_act2l(mlink,hbj)
        Cj(0)=Cfactor*(act2lj(0)-actlj(0)**2) ! From entire statistics.
        if(nbeta.eq.0) then
          write(iuo,'(/,3X,"From entire statistics: ",/)') 
          write(iuo,'(3X,"actlj(0),act2lj(0),Cj(0) =",3G14.5)') 
     &                    actlj(0),act2lj(0),Cj(0)
          write(iuo,'(/,1X,"Jackknife analysis:")') 
          if(ltest) write(iuo,
     &              '(/,2X,"irpt",4X,"actlj",9X,"act2lj",9X,"Cj",/)') 
        endif
        rewind iud1
        read(iud1) nrpt_in,nmeas_in
        do irpt=1,nrpt
          read(iud1) ha,acpt,irpt_in
          do ilink=0,mlink
            haj(ilink)=hasum(ilink)-ha(ilink)
          enddo
          call potts_rwght(mlink,haj,hae,beta,beta0,hbj,hbe)
          actlj(irpt)=potts_actl(mlink,hbj)
          act2lj(irpt)=potts_act2l(mlink,hbj)
          Cj(irpt)=Cfactor*(act2lj(irpt)-actlj(irpt)**2) ! From Jbins.
          if(nbeta.eq.0.and.ltest) write(iuo,'(I6,3G14.5)') 
     &               irpt,actlj(irpt),act2lj(irpt),Cj(irpt)
        enddo
        call stebj0(nrpt,actlj(1),actljm,av,actlme)
        call bias(nrpt,actlj(1),actlj(0),actlm,abm)
        call stebj0(nrpt,Cj(1),Cjm,Cv,Ce)
        call bias(nrpt,Cj(1),Cj(0),Cm,Cbm)
        if(nbeta.eq.0) then
          write(iuo,'(/,3X,"actljm =",F10.6,2X,"+/-",F10.6)') 
     &                      actljm,actlme
          write(iuo,'(3X,"bias =  ",F10.6)') abm
          write(iuo,'(3X,"actlm = ",F10.6,2X,"bias corrected")') actlm
          write(iuo,'(/,3X,"Cjm =   ",F10.6,2X,"+/-",F10.6)') Cjm,Ce
          write(iuo,'(3X,"bias =  ",F10.6)') Cbm
          write(iuo,'(3X,"Cm =    ",F10.6,2X,"bias corrected",/)') Cm
        else
          write(iud2,'(7F11.7)') beta0,actljm,actlm,actlme,Cjm,Cm,Ce 
        endif
      enddo
      close(iud2)
      close(iud1)
C
      stop
      end


      include '../../Libs/Fortran/bias.f'
      include '../../Libs/Fortran/razero.f'
      include '../../Libs/Fortran/rmaset.f'
      include '../../Libs/Fortran/ranmar.f'
      include '../../Libs/Fortran/rmasave.f'
      include '../../Libs/Fortran/ipointer.f'
      include '../../Libs/Fortran/ixcor.f'
      include '../../Libs/Fortran/isfun.f'
      include '../../Libs/Fortran/lat_init.f'
      include '../../Libs/Fortran/nsfun.f'
      include '../../Libs/Fortran/potts_act.f'
      include '../../Libs/Fortran/potts_act_tab.f'
      include '../../Libs/Fortran/potts_actl.f'
      include '../../Libs/Fortran/potts_act2l.f'
      include '../../Libs/Fortran/potts_ran.f'
      include '../../Libs/Fortran/potts_rwght.f'
      include '../../Libs/Fortran/stebj0.f'
      include '../../Libs/Fortran/stmean.f'

